// Generated from dns.json. Do not edit!
#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <string.h>
#include <read_file.h>
#include "cni_network_dns.h"

cni_network_dns *make_cni_network_dns(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    cni_network_dns *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val tmp = get_val(tree, "nameservers", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->nameservers_len = YAJL_GET_ARRAY(tmp)->len;
            ret->nameservers = smart_safe_malloc(YAJL_GET_ARRAY(tmp)->len, 1, sizeof(*ret->nameservers));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->nameservers[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val val = get_val(tree, "domain", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->domain = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val tmp = get_val(tree, "search", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->search_len = YAJL_GET_ARRAY(tmp)->len;
            ret->search = smart_safe_malloc(YAJL_GET_ARRAY(tmp)->len, 1, sizeof(*ret->search));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->search[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "options", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->options_len = YAJL_GET_ARRAY(tmp)->len;
            ret->options = smart_safe_malloc(YAJL_GET_ARRAY(tmp)->len, 1, sizeof(*ret->options));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->options[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_cni_network_dns(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_cni_network_dns(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_cni_network_dns(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "nameservers") &&
                strcmp(tree->u.object.keys[i], "domain") &&
                strcmp(tree->u.object.keys[i], "search") &&
                strcmp(tree->u.object.keys[i], "options"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_cni_network_dns(cni_network_dns *ptr) {
    if (ptr == NULL)
        return;
    if (ptr->nameservers != NULL) {
        size_t i;
        for (i = 0; i < ptr->nameservers_len; i++) {
            if (ptr->nameservers[i] != NULL) {
                free(ptr->nameservers[i]);
                ptr->nameservers[i] = NULL;
            }
        }
        free(ptr->nameservers);
        ptr->nameservers = NULL;
    }
    free(ptr->domain);
    ptr->domain = NULL;
    if (ptr->search != NULL) {
        size_t i;
        for (i = 0; i < ptr->search_len; i++) {
            if (ptr->search[i] != NULL) {
                free(ptr->search[i]);
                ptr->search[i] = NULL;
            }
        }
        free(ptr->search);
        ptr->search = NULL;
    }
    if (ptr->options != NULL) {
        size_t i;
        for (i = 0; i < ptr->options_len; i++) {
            if (ptr->options[i] != NULL) {
                free(ptr->options[i]);
                ptr->options[i] = NULL;
            }
        }
        free(ptr->options);
        ptr->options = NULL;
    }
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_cni_network_dns(yajl_gen g, const cni_network_dns *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->nameservers != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("nameservers"), strlen("nameservers"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->nameservers != NULL) {
            len = ptr->nameservers_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->nameservers[i]), strlen(ptr->nameservers[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->domain != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("domain"), strlen("domain"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->domain != NULL) {
            str = ptr->domain;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->search != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("search"), strlen("search"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->search != NULL) {
            len = ptr->search_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->search[i]), strlen(ptr->search[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->options != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("options"), strlen("options"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->options != NULL) {
            len = ptr->options_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->options[i]), strlen(ptr->options[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}


cni_network_dns *cni_network_dns_parse_file(const char *filename, const struct parser_context *ctx, parser_error *err) {
    cni_network_dns *ptr = NULL;
    size_t filesize;
    char *content = NULL;

    if (filename == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = read_file(filename, &filesize);
    if (content == NULL) {
        if (asprintf(err, "cannot read the file: %s", filename) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = cni_network_dns_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

cni_network_dns *cni_network_dns_parse_file_stream(FILE *stream, const struct parser_context *ctx, parser_error *err) {
    cni_network_dns *ptr = NULL;
    size_t filesize;
    char *content = NULL ;

    if (stream == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = fread_file(stream, &filesize);
    if (content == NULL) {
        *err = safe_strdup("cannot read the file");
        return NULL;
    }
    ptr = cni_network_dns_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

cni_network_dns *cni_network_dns_parse_data(const char *jsondata, const struct parser_context *ctx, parser_error *err) {
    cni_network_dns *ptr = NULL;
    yajl_val tree;
    char errbuf[1024];
    struct parser_context tmp_ctx = { 0 };

    if (jsondata == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (strlen(jsondata) >= JSON_MAX_SIZE) {
        if (asprintf(err, "cannot parse the data with length exceeding %llu", JSON_MAX_SIZE) < 0) {
            *err = safe_strdup("error allocating memory");
        }
        return NULL;
    }
    if (ctx == NULL) {
       ctx = (const struct parser_context *)(&tmp_ctx);
    }
    tree = yajl_tree_parse(jsondata, errbuf, sizeof(errbuf));
    if (tree == NULL) {
        if (asprintf(err, "cannot parse the data: %s", errbuf) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = make_cni_network_dns(tree, ctx, err);
    yajl_tree_free(tree);
    return ptr;
}
char *cni_network_dns_generate_json(const cni_network_dns *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen g = NULL;
    struct parser_context tmp_ctx = { 0 };
    const unsigned char *gen_buf = NULL;
    char *json_buf = NULL;
    size_t gen_len = 0;

    if (ptr == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
        ctx = (const struct parser_context *)(&tmp_ctx);
    }

    if (!json_gen_init(&g, ctx)) {
        *err = safe_strdup("Json_gen init failed");
        goto out;
    }
    if (yajl_gen_status_ok != gen_cni_network_dns(g, ptr, ctx, err)) {
        if (*err == NULL)
            *err = safe_strdup("Failed to generate json");
        goto free_out;
    }
    yajl_gen_get_buf(g, &gen_buf, &gen_len);
    if (gen_buf == NULL) {
        *err = safe_strdup("Error to get generated json");
        goto free_out;
    }

    json_buf = smart_safe_malloc(gen_len, 1, 1);
    (void)memcpy(json_buf, gen_buf, gen_len);
    json_buf[gen_len] = '\0';

free_out:
    yajl_gen_clear(g);
    yajl_gen_free(g);
out:
    return json_buf;
}

