// Generated from result_curr.json. Do not edit!
#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <string.h>
#include <read_file.h>
#include "cni_result_curr.h"

cni_result_curr *make_cni_result_curr(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    cni_result_curr *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "cniVersion", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->cni_version = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val tmp = get_val(tree, "interfaces", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->interfaces_len = YAJL_GET_ARRAY(tmp)->len;
            ret->interfaces = smart_safe_malloc(YAJL_GET_ARRAY(tmp)->len, 1, sizeof(*ret->interfaces));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->interfaces[i] = make_cni_network_interface(val, ctx, err);
                if (ret->interfaces[i] == NULL) {
                    free_cni_result_curr(ret);
                    return NULL;
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "ips", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->ips_len = YAJL_GET_ARRAY(tmp)->len;
            ret->ips = smart_safe_malloc(YAJL_GET_ARRAY(tmp)->len, 1, sizeof(*ret->ips));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->ips[i] = make_cni_network_ipconfig(val, ctx, err);
                if (ret->ips[i] == NULL) {
                    free_cni_result_curr(ret);
                    return NULL;
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "routes", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->routes_len = YAJL_GET_ARRAY(tmp)->len;
            ret->routes = smart_safe_malloc(YAJL_GET_ARRAY(tmp)->len, 1, sizeof(*ret->routes));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->routes[i] = make_cni_network_route(val, ctx, err);
                if (ret->routes[i] == NULL) {
                    free_cni_result_curr(ret);
                    return NULL;
                }
            }
        }
    }
    ret->ip4 = make_cni_network_ipconfig_020(get_val(tree, "ip4", yajl_t_object), ctx, err);
    if (ret->ip4 == NULL && *err != 0) {
        free_cni_result_curr(ret);
        return NULL;
    }
    ret->ip6 = make_cni_network_ipconfig_020(get_val(tree, "ip6", yajl_t_object), ctx, err);
    if (ret->ip6 == NULL && *err != 0) {
        free_cni_result_curr(ret);
        return NULL;
    }
    ret->dns = make_cni_network_dns(get_val(tree, "dns", yajl_t_object), ctx, err);
    if (ret->dns == NULL && *err != 0) {
        free_cni_result_curr(ret);
        return NULL;
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_cni_result_curr(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_cni_result_curr(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_cni_result_curr(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "cniVersion") &&
                strcmp(tree->u.object.keys[i], "interfaces") &&
                strcmp(tree->u.object.keys[i], "ips") &&
                strcmp(tree->u.object.keys[i], "routes") &&
                strcmp(tree->u.object.keys[i], "ip4") &&
                strcmp(tree->u.object.keys[i], "ip6") &&
                strcmp(tree->u.object.keys[i], "dns"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_cni_result_curr(cni_result_curr *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->cni_version);
    ptr->cni_version = NULL;
    if (ptr->interfaces != NULL) {
        size_t i;
        for (i = 0; i < ptr->interfaces_len; i++)
            if (ptr->interfaces[i] != NULL) {
                free_cni_network_interface(ptr->interfaces[i]);
                ptr->interfaces[i] = NULL;
            }
        free(ptr->interfaces);
        ptr->interfaces = NULL;
    }
    if (ptr->ips != NULL) {
        size_t i;
        for (i = 0; i < ptr->ips_len; i++)
            if (ptr->ips[i] != NULL) {
                free_cni_network_ipconfig(ptr->ips[i]);
                ptr->ips[i] = NULL;
            }
        free(ptr->ips);
        ptr->ips = NULL;
    }
    if (ptr->routes != NULL) {
        size_t i;
        for (i = 0; i < ptr->routes_len; i++)
            if (ptr->routes[i] != NULL) {
                free_cni_network_route(ptr->routes[i]);
                ptr->routes[i] = NULL;
            }
        free(ptr->routes);
        ptr->routes = NULL;
    }
    if (ptr->ip4 != NULL) {
        free_cni_network_ipconfig_020(ptr->ip4);
        ptr->ip4 = NULL;
    }
    if (ptr->ip6 != NULL) {
        free_cni_network_ipconfig_020(ptr->ip6);
        ptr->ip6 = NULL;
    }
    if (ptr->dns != NULL) {
        free_cni_network_dns(ptr->dns);
        ptr->dns = NULL;
    }
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_cni_result_curr(yajl_gen g, const cni_result_curr *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->cni_version != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("cniVersion"), strlen("cniVersion"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->cni_version != NULL) {
            str = ptr->cni_version;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->interfaces != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("interfaces"), strlen("interfaces"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->interfaces != NULL) {
            len = ptr->interfaces_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_cni_network_interface(g, ptr->interfaces[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->ips != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("ips"), strlen("ips"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->ips != NULL) {
            len = ptr->ips_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_cni_network_ipconfig(g, ptr->ips[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->routes != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("routes"), strlen("routes"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->routes != NULL) {
            len = ptr->routes_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_cni_network_route(g, ptr->routes[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->ip4 != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("ip4"), strlen("ip4"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_cni_network_ipconfig_020(g, ptr != NULL ? ptr->ip4 : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->ip6 != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("ip6"), strlen("ip6"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_cni_network_ipconfig_020(g, ptr != NULL ? ptr->ip6 : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->dns != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("dns"), strlen("dns"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_cni_network_dns(g, ptr != NULL ? ptr->dns : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}


cni_result_curr *cni_result_curr_parse_file(const char *filename, const struct parser_context *ctx, parser_error *err) {
    cni_result_curr *ptr = NULL;
    size_t filesize;
    char *content = NULL;

    if (filename == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = read_file(filename, &filesize);
    if (content == NULL) {
        if (asprintf(err, "cannot read the file: %s", filename) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = cni_result_curr_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

cni_result_curr *cni_result_curr_parse_file_stream(FILE *stream, const struct parser_context *ctx, parser_error *err) {
    cni_result_curr *ptr = NULL;
    size_t filesize;
    char *content = NULL ;

    if (stream == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = fread_file(stream, &filesize);
    if (content == NULL) {
        *err = safe_strdup("cannot read the file");
        return NULL;
    }
    ptr = cni_result_curr_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

cni_result_curr *cni_result_curr_parse_data(const char *jsondata, const struct parser_context *ctx, parser_error *err) {
    cni_result_curr *ptr = NULL;
    yajl_val tree;
    char errbuf[1024];
    struct parser_context tmp_ctx = { 0 };

    if (jsondata == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (strlen(jsondata) >= JSON_MAX_SIZE) {
        if (asprintf(err, "cannot parse the data with length exceeding %llu", JSON_MAX_SIZE) < 0) {
            *err = safe_strdup("error allocating memory");
        }
        return NULL;
    }
    if (ctx == NULL) {
       ctx = (const struct parser_context *)(&tmp_ctx);
    }
    tree = yajl_tree_parse(jsondata, errbuf, sizeof(errbuf));
    if (tree == NULL) {
        if (asprintf(err, "cannot parse the data: %s", errbuf) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = make_cni_result_curr(tree, ctx, err);
    yajl_tree_free(tree);
    return ptr;
}
char *cni_result_curr_generate_json(const cni_result_curr *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen g = NULL;
    struct parser_context tmp_ctx = { 0 };
    const unsigned char *gen_buf = NULL;
    char *json_buf = NULL;
    size_t gen_len = 0;

    if (ptr == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
        ctx = (const struct parser_context *)(&tmp_ctx);
    }

    if (!json_gen_init(&g, ctx)) {
        *err = safe_strdup("Json_gen init failed");
        goto out;
    }
    if (yajl_gen_status_ok != gen_cni_result_curr(g, ptr, ctx, err)) {
        if (*err == NULL)
            *err = safe_strdup("Failed to generate json");
        goto free_out;
    }
    yajl_gen_get_buf(g, &gen_buf, &gen_len);
    if (gen_buf == NULL) {
        *err = safe_strdup("Error to get generated json");
        goto free_out;
    }

    json_buf = smart_safe_malloc(gen_len, 1, 1);
    (void)memcpy(json_buf, gen_buf, gen_len);
    json_buf[gen_len] = '\0';

free_out:
    yajl_gen_clear(g);
    yajl_gen_free(g);
out:
    return json_buf;
}

