// Generated from seccomp.json. Do not edit!
#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <string.h>
#include <read_file.h>
#include "docker_seccomp.h"

docker_seccomp_arch_map_element *make_docker_seccomp_arch_map_element(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    docker_seccomp_arch_map_element *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "architecture", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->architecture = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val tmp = get_val(tree, "subArchitectures", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->sub_architectures_len = YAJL_GET_ARRAY(tmp)->len;
            ret->sub_architectures = smart_safe_malloc(YAJL_GET_ARRAY(tmp)->len, 1, sizeof(*ret->sub_architectures));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->sub_architectures[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    return ret;
}

void free_docker_seccomp_arch_map_element(docker_seccomp_arch_map_element *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->architecture);
    ptr->architecture = NULL;
    if (ptr->sub_architectures != NULL) {
        size_t i;
        for (i = 0; i < ptr->sub_architectures_len; i++) {
            if (ptr->sub_architectures[i] != NULL) {
                free(ptr->sub_architectures[i]);
                ptr->sub_architectures[i] = NULL;
            }
        }
        free(ptr->sub_architectures);
        ptr->sub_architectures = NULL;
    }
    free(ptr);
}

yajl_gen_status gen_docker_seccomp_arch_map_element(yajl_gen g, const docker_seccomp_arch_map_element *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->architecture != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("architecture"), strlen("architecture"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->architecture != NULL) {
            str = ptr->architecture;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->sub_architectures != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("subArchitectures"), strlen("subArchitectures"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->sub_architectures != NULL) {
            len = ptr->sub_architectures_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->sub_architectures[i]), strlen(ptr->sub_architectures[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

docker_seccomp_syscalls_args_element *make_docker_seccomp_syscalls_args_element(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    docker_seccomp_syscalls_args_element *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "index", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_uint32(YAJL_GET_NUMBER(val), &ret->index);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'uint32' for key 'index': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_docker_seccomp_syscalls_args_element(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "value", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_uint64(YAJL_GET_NUMBER(val), &ret->value);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'uint64' for key 'value': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_docker_seccomp_syscalls_args_element(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "valueTwo", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_uint64(YAJL_GET_NUMBER(val), &ret->value_two);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'uint64' for key 'valueTwo': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_docker_seccomp_syscalls_args_element(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "op", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->op = safe_strdup(str ? str : "");
        }
    }
    if (ret->op == NULL) {
        if (asprintf(err, "Required field '%s' not present",  "op") < 0)
            *err = safe_strdup("error allocating memory");
        free_docker_seccomp_syscalls_args_element(ret);
        return NULL;
    }
    return ret;
}

void free_docker_seccomp_syscalls_args_element(docker_seccomp_syscalls_args_element *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->op);
    ptr->op = NULL;
    free(ptr);
}

yajl_gen_status gen_docker_seccomp_syscalls_args_element(yajl_gen g, const docker_seccomp_syscalls_args_element *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->index)) {
        long long unsigned int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("index"), strlen("index"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->index) {
            num = (long long unsigned int)ptr->index;
        }
        stat = map_uint(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->value)) {
        long long unsigned int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("value"), strlen("value"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->value) {
            num = (long long unsigned int)ptr->value;
        }
        stat = map_uint(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->value_two)) {
        long long unsigned int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("valueTwo"), strlen("valueTwo"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->value_two) {
            num = (long long unsigned int)ptr->value_two;
        }
        stat = map_uint(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->op != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("op"), strlen("op"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->op != NULL) {
            str = ptr->op;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

docker_seccomp_syscalls_includes *make_docker_seccomp_syscalls_includes(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    docker_seccomp_syscalls_includes *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val tmp = get_val(tree, "arches", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->arches_len = YAJL_GET_ARRAY(tmp)->len;
            ret->arches = smart_safe_malloc(YAJL_GET_ARRAY(tmp)->len, 1, sizeof(*ret->arches));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->arches[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "caps", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->caps_len = YAJL_GET_ARRAY(tmp)->len;
            ret->caps = smart_safe_malloc(YAJL_GET_ARRAY(tmp)->len, 1, sizeof(*ret->caps));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->caps[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_docker_seccomp_syscalls_includes(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_docker_seccomp_syscalls_includes(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_docker_seccomp_syscalls_includes(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "arches") &&
                strcmp(tree->u.object.keys[i], "caps"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_docker_seccomp_syscalls_includes(docker_seccomp_syscalls_includes *ptr) {
    if (ptr == NULL)
        return;
    if (ptr->arches != NULL) {
        size_t i;
        for (i = 0; i < ptr->arches_len; i++) {
            if (ptr->arches[i] != NULL) {
                free(ptr->arches[i]);
                ptr->arches[i] = NULL;
            }
        }
        free(ptr->arches);
        ptr->arches = NULL;
    }
    if (ptr->caps != NULL) {
        size_t i;
        for (i = 0; i < ptr->caps_len; i++) {
            if (ptr->caps[i] != NULL) {
                free(ptr->caps[i]);
                ptr->caps[i] = NULL;
            }
        }
        free(ptr->caps);
        ptr->caps = NULL;
    }
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_docker_seccomp_syscalls_includes(yajl_gen g, const docker_seccomp_syscalls_includes *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->arches != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("arches"), strlen("arches"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->arches != NULL) {
            len = ptr->arches_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->arches[i]), strlen(ptr->arches[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->caps != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("caps"), strlen("caps"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->caps != NULL) {
            len = ptr->caps_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->caps[i]), strlen(ptr->caps[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

docker_seccomp_syscalls_excludes *make_docker_seccomp_syscalls_excludes(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    docker_seccomp_syscalls_excludes *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val tmp = get_val(tree, "arches", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->arches_len = YAJL_GET_ARRAY(tmp)->len;
            ret->arches = smart_safe_malloc(YAJL_GET_ARRAY(tmp)->len, 1, sizeof(*ret->arches));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->arches[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "caps", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->caps_len = YAJL_GET_ARRAY(tmp)->len;
            ret->caps = smart_safe_malloc(YAJL_GET_ARRAY(tmp)->len, 1, sizeof(*ret->caps));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->caps[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_docker_seccomp_syscalls_excludes(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_docker_seccomp_syscalls_excludes(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_docker_seccomp_syscalls_excludes(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "arches") &&
                strcmp(tree->u.object.keys[i], "caps"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_docker_seccomp_syscalls_excludes(docker_seccomp_syscalls_excludes *ptr) {
    if (ptr == NULL)
        return;
    if (ptr->arches != NULL) {
        size_t i;
        for (i = 0; i < ptr->arches_len; i++) {
            if (ptr->arches[i] != NULL) {
                free(ptr->arches[i]);
                ptr->arches[i] = NULL;
            }
        }
        free(ptr->arches);
        ptr->arches = NULL;
    }
    if (ptr->caps != NULL) {
        size_t i;
        for (i = 0; i < ptr->caps_len; i++) {
            if (ptr->caps[i] != NULL) {
                free(ptr->caps[i]);
                ptr->caps[i] = NULL;
            }
        }
        free(ptr->caps);
        ptr->caps = NULL;
    }
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_docker_seccomp_syscalls_excludes(yajl_gen g, const docker_seccomp_syscalls_excludes *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->arches != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("arches"), strlen("arches"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->arches != NULL) {
            len = ptr->arches_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->arches[i]), strlen(ptr->arches[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->caps != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("caps"), strlen("caps"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->caps != NULL) {
            len = ptr->caps_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->caps[i]), strlen(ptr->caps[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

docker_seccomp_syscalls_element *make_docker_seccomp_syscalls_element(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    docker_seccomp_syscalls_element *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val tmp = get_val(tree, "names", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->names_len = YAJL_GET_ARRAY(tmp)->len;
            ret->names = smart_safe_malloc(YAJL_GET_ARRAY(tmp)->len, 1, sizeof(*ret->names));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->names[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val val = get_val(tree, "action", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->action = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val tmp = get_val(tree, "args", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->args_len = YAJL_GET_ARRAY(tmp)->len;
            ret->args = smart_safe_malloc(YAJL_GET_ARRAY(tmp)->len, 1, sizeof(*ret->args));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->args[i] = make_docker_seccomp_syscalls_args_element(val, ctx, err);
                if (ret->args[i] == NULL) {
                    free_docker_seccomp_syscalls_element(ret);
                    return NULL;
                }
            }
        }
    }
    {
        yajl_val val = get_val(tree, "comment", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->comment = safe_strdup(str ? str : "");
        }
    }
    ret->includes = make_docker_seccomp_syscalls_includes(get_val(tree, "includes", yajl_t_object), ctx, err);
    if (ret->includes == NULL && *err != 0) {
        free_docker_seccomp_syscalls_element(ret);
        return NULL;
    }
    ret->excludes = make_docker_seccomp_syscalls_excludes(get_val(tree, "excludes", yajl_t_object), ctx, err);
    if (ret->excludes == NULL && *err != 0) {
        free_docker_seccomp_syscalls_element(ret);
        return NULL;
    }
    if (ret->names == NULL) {
        if (asprintf(err, "Required field '%s' not present",  "names") < 0)
            *err = safe_strdup("error allocating memory");
        free_docker_seccomp_syscalls_element(ret);
        return NULL;
    }
    if (ret->action == NULL) {
        if (asprintf(err, "Required field '%s' not present",  "action") < 0)
            *err = safe_strdup("error allocating memory");
        free_docker_seccomp_syscalls_element(ret);
        return NULL;
    }
    return ret;
}

void free_docker_seccomp_syscalls_element(docker_seccomp_syscalls_element *ptr) {
    if (ptr == NULL)
        return;
    if (ptr->names != NULL) {
        size_t i;
        for (i = 0; i < ptr->names_len; i++) {
            if (ptr->names[i] != NULL) {
                free(ptr->names[i]);
                ptr->names[i] = NULL;
            }
        }
        free(ptr->names);
        ptr->names = NULL;
    }
    free(ptr->action);
    ptr->action = NULL;
    if (ptr->args != NULL) {
        size_t i;
        for (i = 0; i < ptr->args_len; i++)
            if (ptr->args[i] != NULL) {
                free_docker_seccomp_syscalls_args_element(ptr->args[i]);
                ptr->args[i] = NULL;
            }
        free(ptr->args);
        ptr->args = NULL;
    }
    free(ptr->comment);
    ptr->comment = NULL;
    if (ptr->includes != NULL) {
        free_docker_seccomp_syscalls_includes(ptr->includes);
        ptr->includes = NULL;
    }
    if (ptr->excludes != NULL) {
        free_docker_seccomp_syscalls_excludes(ptr->excludes);
        ptr->excludes = NULL;
    }
    free(ptr);
}

yajl_gen_status gen_docker_seccomp_syscalls_element(yajl_gen g, const docker_seccomp_syscalls_element *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->names != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("names"), strlen("names"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->names != NULL) {
            len = ptr->names_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->names[i]), strlen(ptr->names[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->action != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("action"), strlen("action"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->action != NULL) {
            str = ptr->action;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->args != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("args"), strlen("args"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->args != NULL) {
            len = ptr->args_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_docker_seccomp_syscalls_args_element(g, ptr->args[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->comment != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("comment"), strlen("comment"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->comment != NULL) {
            str = ptr->comment;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->includes != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("includes"), strlen("includes"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_docker_seccomp_syscalls_includes(g, ptr != NULL ? ptr->includes : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->excludes != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("excludes"), strlen("excludes"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_docker_seccomp_syscalls_excludes(g, ptr != NULL ? ptr->excludes : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

docker_seccomp *make_docker_seccomp(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    docker_seccomp *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "defaultAction", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->default_action = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val tmp = get_val(tree, "archMap", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->arch_map_len = YAJL_GET_ARRAY(tmp)->len;
            ret->arch_map = smart_safe_malloc(YAJL_GET_ARRAY(tmp)->len, 1, sizeof(*ret->arch_map));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->arch_map[i] = make_docker_seccomp_arch_map_element(val, ctx, err);
                if (ret->arch_map[i] == NULL) {
                    free_docker_seccomp(ret);
                    return NULL;
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "syscalls", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->syscalls_len = YAJL_GET_ARRAY(tmp)->len;
            ret->syscalls = smart_safe_malloc(YAJL_GET_ARRAY(tmp)->len, 1, sizeof(*ret->syscalls));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->syscalls[i] = make_docker_seccomp_syscalls_element(val, ctx, err);
                if (ret->syscalls[i] == NULL) {
                    free_docker_seccomp(ret);
                    return NULL;
                }
            }
        }
    }
    if (ret->default_action == NULL) {
        if (asprintf(err, "Required field '%s' not present",  "defaultAction") < 0)
            *err = safe_strdup("error allocating memory");
        free_docker_seccomp(ret);
        return NULL;
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_docker_seccomp(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_docker_seccomp(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_docker_seccomp(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "defaultAction") &&
                strcmp(tree->u.object.keys[i], "archMap") &&
                strcmp(tree->u.object.keys[i], "syscalls"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_docker_seccomp(docker_seccomp *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->default_action);
    ptr->default_action = NULL;
    if (ptr->arch_map != NULL) {
        size_t i;
        for (i = 0; i < ptr->arch_map_len; i++)
            if (ptr->arch_map[i] != NULL) {
                free_docker_seccomp_arch_map_element(ptr->arch_map[i]);
                ptr->arch_map[i] = NULL;
            }
        free(ptr->arch_map);
        ptr->arch_map = NULL;
    }
    if (ptr->syscalls != NULL) {
        size_t i;
        for (i = 0; i < ptr->syscalls_len; i++)
            if (ptr->syscalls[i] != NULL) {
                free_docker_seccomp_syscalls_element(ptr->syscalls[i]);
                ptr->syscalls[i] = NULL;
            }
        free(ptr->syscalls);
        ptr->syscalls = NULL;
    }
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_docker_seccomp(yajl_gen g, const docker_seccomp *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->default_action != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("defaultAction"), strlen("defaultAction"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->default_action != NULL) {
            str = ptr->default_action;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->arch_map != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("archMap"), strlen("archMap"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->arch_map != NULL) {
            len = ptr->arch_map_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_docker_seccomp_arch_map_element(g, ptr->arch_map[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->syscalls != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("syscalls"), strlen("syscalls"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->syscalls != NULL) {
            len = ptr->syscalls_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_docker_seccomp_syscalls_element(g, ptr->syscalls[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}


docker_seccomp *docker_seccomp_parse_file(const char *filename, const struct parser_context *ctx, parser_error *err) {
    docker_seccomp *ptr = NULL;
    size_t filesize;
    char *content = NULL;

    if (filename == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = read_file(filename, &filesize);
    if (content == NULL) {
        if (asprintf(err, "cannot read the file: %s", filename) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = docker_seccomp_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

docker_seccomp *docker_seccomp_parse_file_stream(FILE *stream, const struct parser_context *ctx, parser_error *err) {
    docker_seccomp *ptr = NULL;
    size_t filesize;
    char *content = NULL ;

    if (stream == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = fread_file(stream, &filesize);
    if (content == NULL) {
        *err = safe_strdup("cannot read the file");
        return NULL;
    }
    ptr = docker_seccomp_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

docker_seccomp *docker_seccomp_parse_data(const char *jsondata, const struct parser_context *ctx, parser_error *err) {
    docker_seccomp *ptr = NULL;
    yajl_val tree;
    char errbuf[1024];
    struct parser_context tmp_ctx = { 0 };

    if (jsondata == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (strlen(jsondata) >= JSON_MAX_SIZE) {
        if (asprintf(err, "cannot parse the data with length exceeding %llu", JSON_MAX_SIZE) < 0) {
            *err = safe_strdup("error allocating memory");
        }
        return NULL;
    }
    if (ctx == NULL) {
       ctx = (const struct parser_context *)(&tmp_ctx);
    }
    tree = yajl_tree_parse(jsondata, errbuf, sizeof(errbuf));
    if (tree == NULL) {
        if (asprintf(err, "cannot parse the data: %s", errbuf) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = make_docker_seccomp(tree, ctx, err);
    yajl_tree_free(tree);
    return ptr;
}
char *docker_seccomp_generate_json(const docker_seccomp *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen g = NULL;
    struct parser_context tmp_ctx = { 0 };
    const unsigned char *gen_buf = NULL;
    char *json_buf = NULL;
    size_t gen_len = 0;

    if (ptr == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
        ctx = (const struct parser_context *)(&tmp_ctx);
    }

    if (!json_gen_init(&g, ctx)) {
        *err = safe_strdup("Json_gen init failed");
        goto out;
    }
    if (yajl_gen_status_ok != gen_docker_seccomp(g, ptr, ctx, err)) {
        if (*err == NULL)
            *err = safe_strdup("Failed to generate json");
        goto free_out;
    }
    yajl_gen_get_buf(g, &gen_buf, &gen_len);
    if (gen_buf == NULL) {
        *err = safe_strdup("Error to get generated json");
        goto free_out;
    }

    json_buf = smart_safe_malloc(gen_len, 1, 1);
    (void)memcpy(json_buf, gen_buf, gen_len);
    json_buf[gen_len] = '\0';

free_out:
    yajl_gen_clear(g);
    yajl_gen_free(g);
out:
    return json_buf;
}

