// Generated from config.json. Do not edit!
#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <string.h>
#include <read_file.h>
#include "embedded_config.h"

embedded_config *make_embedded_config(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    embedded_config *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val tmp = get_val(tree, "ENV", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->env_len = YAJL_GET_ARRAY(tmp)->len;
            ret->env = smart_safe_malloc(YAJL_GET_ARRAY(tmp)->len, 1, sizeof(*ret->env));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->env[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val tmp = get_val(tree, "ENTRYPOINT", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->entrypoint_len = YAJL_GET_ARRAY(tmp)->len;
            ret->entrypoint = smart_safe_malloc(YAJL_GET_ARRAY(tmp)->len, 1, sizeof(*ret->entrypoint));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                if (val != NULL) {
                    char *str = YAJL_GET_STRING(val);
                    ret->entrypoint[i] = safe_strdup(str ? str : "");
                }
            }
        }
    }
    {
        yajl_val val = get_val(tree, "WORKDIR", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->workdir = safe_strdup(str ? str : "");
        }
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_embedded_config(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_embedded_config(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_embedded_config(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "ENV") &&
                strcmp(tree->u.object.keys[i], "ENTRYPOINT") &&
                strcmp(tree->u.object.keys[i], "WORKDIR"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_embedded_config(embedded_config *ptr) {
    if (ptr == NULL)
        return;
    if (ptr->env != NULL) {
        size_t i;
        for (i = 0; i < ptr->env_len; i++) {
            if (ptr->env[i] != NULL) {
                free(ptr->env[i]);
                ptr->env[i] = NULL;
            }
        }
        free(ptr->env);
        ptr->env = NULL;
    }
    if (ptr->entrypoint != NULL) {
        size_t i;
        for (i = 0; i < ptr->entrypoint_len; i++) {
            if (ptr->entrypoint[i] != NULL) {
                free(ptr->entrypoint[i]);
                ptr->entrypoint[i] = NULL;
            }
        }
        free(ptr->entrypoint);
        ptr->entrypoint = NULL;
    }
    free(ptr->workdir);
    ptr->workdir = NULL;
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_embedded_config(yajl_gen g, const embedded_config *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->env != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("ENV"), strlen("ENV"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->env != NULL) {
            len = ptr->env_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->env[i]), strlen(ptr->env[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->entrypoint != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("ENTRYPOINT"), strlen("ENTRYPOINT"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->entrypoint != NULL) {
            len = ptr->entrypoint_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(ptr->entrypoint[i]), strlen(ptr->entrypoint[i]));
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->workdir != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("WORKDIR"), strlen("WORKDIR"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->workdir != NULL) {
            str = ptr->workdir;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}


embedded_config *embedded_config_parse_file(const char *filename, const struct parser_context *ctx, parser_error *err) {
    embedded_config *ptr = NULL;
    size_t filesize;
    char *content = NULL;

    if (filename == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = read_file(filename, &filesize);
    if (content == NULL) {
        if (asprintf(err, "cannot read the file: %s", filename) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = embedded_config_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

embedded_config *embedded_config_parse_file_stream(FILE *stream, const struct parser_context *ctx, parser_error *err) {
    embedded_config *ptr = NULL;
    size_t filesize;
    char *content = NULL ;

    if (stream == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = fread_file(stream, &filesize);
    if (content == NULL) {
        *err = safe_strdup("cannot read the file");
        return NULL;
    }
    ptr = embedded_config_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

embedded_config *embedded_config_parse_data(const char *jsondata, const struct parser_context *ctx, parser_error *err) {
    embedded_config *ptr = NULL;
    yajl_val tree;
    char errbuf[1024];
    struct parser_context tmp_ctx = { 0 };

    if (jsondata == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (strlen(jsondata) >= JSON_MAX_SIZE) {
        if (asprintf(err, "cannot parse the data with length exceeding %llu", JSON_MAX_SIZE) < 0) {
            *err = safe_strdup("error allocating memory");
        }
        return NULL;
    }
    if (ctx == NULL) {
       ctx = (const struct parser_context *)(&tmp_ctx);
    }
    tree = yajl_tree_parse(jsondata, errbuf, sizeof(errbuf));
    if (tree == NULL) {
        if (asprintf(err, "cannot parse the data: %s", errbuf) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = make_embedded_config(tree, ctx, err);
    yajl_tree_free(tree);
    return ptr;
}
char *embedded_config_generate_json(const embedded_config *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen g = NULL;
    struct parser_context tmp_ctx = { 0 };
    const unsigned char *gen_buf = NULL;
    char *json_buf = NULL;
    size_t gen_len = 0;

    if (ptr == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
        ctx = (const struct parser_context *)(&tmp_ctx);
    }

    if (!json_gen_init(&g, ctx)) {
        *err = safe_strdup("Json_gen init failed");
        goto out;
    }
    if (yajl_gen_status_ok != gen_embedded_config(g, ptr, ctx, err)) {
        if (*err == NULL)
            *err = safe_strdup("Failed to generate json");
        goto free_out;
    }
    yajl_gen_get_buf(g, &gen_buf, &gen_len);
    if (gen_buf == NULL) {
        *err = safe_strdup("Error to get generated json");
        goto free_out;
    }

    json_buf = smart_safe_malloc(gen_len, 1, 1);
    (void)memcpy(json_buf, gen_buf, gen_len);
    json_buf[gen_len] = '\0';

free_out:
    yajl_gen_clear(g);
    yajl_gen_free(g);
out:
    return json_buf;
}

