// Generated from manifest_schema2.json. Do not edit!
#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <string.h>
#include <read_file.h>
#include "registry_manifest_schema2.h"

registry_manifest_schema2_config *make_registry_manifest_schema2_config(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    registry_manifest_schema2_config *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "mediaType", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->media_type = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "size", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int(YAJL_GET_NUMBER(val), (int *)&ret->size);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'integer' for key 'size': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_registry_manifest_schema2_config(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "digest", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->digest = safe_strdup(str ? str : "");
        }
    }
    if (ret->media_type == NULL) {
        if (asprintf(err, "Required field '%s' not present",  "mediaType") < 0)
            *err = safe_strdup("error allocating memory");
        free_registry_manifest_schema2_config(ret);
        return NULL;
    }
    if (ret->digest == NULL) {
        if (asprintf(err, "Required field '%s' not present",  "digest") < 0)
            *err = safe_strdup("error allocating memory");
        free_registry_manifest_schema2_config(ret);
        return NULL;
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_registry_manifest_schema2_config(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_registry_manifest_schema2_config(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_registry_manifest_schema2_config(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "mediaType") &&
                strcmp(tree->u.object.keys[i], "size") &&
                strcmp(tree->u.object.keys[i], "digest"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_registry_manifest_schema2_config(registry_manifest_schema2_config *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->media_type);
    ptr->media_type = NULL;
    free(ptr->digest);
    ptr->digest = NULL;
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_registry_manifest_schema2_config(yajl_gen g, const registry_manifest_schema2_config *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->media_type != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("mediaType"), strlen("mediaType"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->media_type != NULL) {
            str = ptr->media_type;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->size)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("size"), strlen("size"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->size) {
            num = (long long int)ptr->size;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->digest != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("digest"), strlen("digest"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->digest != NULL) {
            str = ptr->digest;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

registry_manifest_schema2_layers_element *make_registry_manifest_schema2_layers_element(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    registry_manifest_schema2_layers_element *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "mediaType", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->media_type = safe_strdup(str ? str : "");
        }
    }
    {
        yajl_val val = get_val(tree, "size", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int64(YAJL_GET_NUMBER(val), &ret->size);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'int64' for key 'size': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_registry_manifest_schema2_layers_element(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "digest", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->digest = safe_strdup(str ? str : "");
        }
    }
    if (ret->media_type == NULL) {
        if (asprintf(err, "Required field '%s' not present",  "mediaType") < 0)
            *err = safe_strdup("error allocating memory");
        free_registry_manifest_schema2_layers_element(ret);
        return NULL;
    }
    if (ret->digest == NULL) {
        if (asprintf(err, "Required field '%s' not present",  "digest") < 0)
            *err = safe_strdup("error allocating memory");
        free_registry_manifest_schema2_layers_element(ret);
        return NULL;
    }
    return ret;
}

void free_registry_manifest_schema2_layers_element(registry_manifest_schema2_layers_element *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->media_type);
    ptr->media_type = NULL;
    free(ptr->digest);
    ptr->digest = NULL;
    free(ptr);
}

yajl_gen_status gen_registry_manifest_schema2_layers_element(yajl_gen g, const registry_manifest_schema2_layers_element *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->media_type != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("mediaType"), strlen("mediaType"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->media_type != NULL) {
            str = ptr->media_type;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->size)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("size"), strlen("size"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->size) {
            num = (long long int)ptr->size;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->digest != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("digest"), strlen("digest"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->digest != NULL) {
            str = ptr->digest;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}

registry_manifest_schema2 *make_registry_manifest_schema2(yajl_val tree, const struct parser_context *ctx, parser_error *err) {
    registry_manifest_schema2 *ret = NULL;
    *err = 0;
    if (tree == NULL)
        return ret;
    ret = safe_malloc(sizeof(*ret));
    {
        yajl_val val = get_val(tree, "schemaVersion", yajl_t_number);
        if (val != NULL) {
            int invalid = common_safe_int(YAJL_GET_NUMBER(val), (int *)&ret->schema_version);
            if (invalid) {
                if (asprintf(err, "Invalid value '%s' with type 'integer' for key 'schemaVersion': %s", YAJL_GET_NUMBER(val), strerror(-invalid)) < 0)
                    *err = safe_strdup("error allocating memory");
                free_registry_manifest_schema2(ret);
                return NULL;
            }
        }
    }
    {
        yajl_val val = get_val(tree, "mediaType", yajl_t_string);
        if (val != NULL) {
            char *str = YAJL_GET_STRING(val);
            ret->media_type = safe_strdup(str ? str : "");
        }
    }
    ret->config = make_registry_manifest_schema2_config(get_val(tree, "config", yajl_t_object), ctx, err);
    if (ret->config == NULL && *err != 0) {
        free_registry_manifest_schema2(ret);
        return NULL;
    }
    {
        yajl_val tmp = get_val(tree, "layers", yajl_t_array);
        if (tmp != NULL && YAJL_GET_ARRAY(tmp) != NULL && YAJL_GET_ARRAY(tmp)->len > 0) {
            size_t i;
            ret->layers_len = YAJL_GET_ARRAY(tmp)->len;
            ret->layers = smart_safe_malloc(YAJL_GET_ARRAY(tmp)->len, 1, sizeof(*ret->layers));
            for (i = 0; i < YAJL_GET_ARRAY(tmp)->len; i++) {
                yajl_val val = YAJL_GET_ARRAY(tmp)->values[i];
                ret->layers[i] = make_registry_manifest_schema2_layers_element(val, ctx, err);
                if (ret->layers[i] == NULL) {
                    free_registry_manifest_schema2(ret);
                    return NULL;
                }
            }
        }
    }
    if (ret->media_type == NULL) {
        if (asprintf(err, "Required field '%s' not present",  "mediaType") < 0)
            *err = safe_strdup("error allocating memory");
        free_registry_manifest_schema2(ret);
        return NULL;
    }
    if (ret->config == NULL) {
        if (asprintf(err, "Required field '%s' not present",  "config") < 0)
            *err = safe_strdup("error allocating memory");
        free_registry_manifest_schema2(ret);
        return NULL;
    }

    if (tree->type == yajl_t_object)
    {
        size_t i;
        size_t j = 0;
        size_t cnt = tree->u.object.len;
        yajl_val resi = NULL;

        if (ctx->options & OPT_PARSE_FULLKEY)
        {
            resi = calloc (1, sizeof(*tree));
            if (resi == NULL)
            {
                free_registry_manifest_schema2(ret);
                return NULL;
            }
            resi->type = yajl_t_object;
            resi->u.object.keys = calloc (cnt, sizeof (const char *));
            if (resi->u.object.keys == NULL)
            {
               free_registry_manifest_schema2(ret);
               yajl_tree_free(resi);
               return NULL;
            }
            resi->u.object.values = calloc (cnt, sizeof (yajl_val));
            if (resi->u.object.values == NULL)
            {
               free_registry_manifest_schema2(ret);
               yajl_tree_free(resi);
               return NULL;
            }
        }
        for (i = 0; i < tree->u.object.len; i++)
        {
           if (strcmp(tree->u.object.keys[i], "schemaVersion") &&
                strcmp(tree->u.object.keys[i], "mediaType") &&
                strcmp(tree->u.object.keys[i], "config") &&
                strcmp(tree->u.object.keys[i], "layers"))
           {
              if (ctx->options & OPT_PARSE_FULLKEY)
              {
                 resi->u.object.keys[j] = tree->u.object.keys[i];
                 tree->u.object.keys[i] = NULL;
                 resi->u.object.values[j] = tree->u.object.values[i];
                 tree->u.object.values[i] = NULL;
                 resi->u.object.len++;
              }
              j++;
           }
        }
        if (ctx->options & OPT_PARSE_STRICT)
        {
            if (j > 0 && ctx->stderr > 0)
                fprintf (ctx->stderr, "WARNING: unknown key found\n");
        }
        if (ctx->options & OPT_PARSE_FULLKEY)
            ret->_residual = resi;
        }
    return ret;
}

void free_registry_manifest_schema2(registry_manifest_schema2 *ptr) {
    if (ptr == NULL)
        return;
    free(ptr->media_type);
    ptr->media_type = NULL;
    if (ptr->config != NULL) {
        free_registry_manifest_schema2_config(ptr->config);
        ptr->config = NULL;
    }
    if (ptr->layers != NULL) {
        size_t i;
        for (i = 0; i < ptr->layers_len; i++)
            if (ptr->layers[i] != NULL) {
                free_registry_manifest_schema2_layers_element(ptr->layers[i]);
                ptr->layers[i] = NULL;
            }
        free(ptr->layers);
        ptr->layers = NULL;
    }
    yajl_tree_free (ptr->_residual);
    ptr->_residual = NULL;
    free(ptr);
}

yajl_gen_status gen_registry_manifest_schema2(yajl_gen g, const registry_manifest_schema2 *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen_status stat = yajl_gen_status_ok;
    *err = 0;
    stat = yajl_gen_map_open((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->schema_version)) {
        long long int num = 0;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("schemaVersion"), strlen("schemaVersion"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->schema_version) {
            num = (long long int)ptr->schema_version;
        }
        stat = map_int(g, num);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->media_type != NULL)) {
        char *str = "";
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("mediaType"), strlen("mediaType"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->media_type != NULL) {
            str = ptr->media_type;
        }
        stat = yajl_gen_string((yajl_gen)g,         (const unsigned char *)(str), strlen(str));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->config != NULL)) {
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("config"), strlen("config"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        stat = gen_registry_manifest_schema2_config(g, ptr != NULL ? ptr->config : NULL, ctx, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if ((ctx->options & OPT_GEN_KAY_VALUE) || (ptr != NULL && ptr->layers != NULL)) {
        size_t len = 0, i;
        stat = yajl_gen_string((yajl_gen)g,             (const unsigned char *)("layers"), strlen("layers"));
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        if (ptr != NULL && ptr->layers != NULL) {
            len = ptr->layers_len;
        }
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 0);
        stat = yajl_gen_array_open((yajl_gen)g);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
        for (i = 0; i < len; i++) {
            stat = gen_registry_manifest_schema2_layers_element(g, ptr->layers[i], ctx, err);
            if (yajl_gen_status_ok != stat)
                GEN_SET_ERROR_AND_RETURN(stat, err);
        }
        stat = yajl_gen_array_close((yajl_gen)g);
        if (!len && !(ctx->options & OPT_GEN_SIMPLIFY))
            yajl_gen_config(g, yajl_gen_beautify, 1);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN(stat, err);
    }
    if (ptr != NULL && ptr->_residual != NULL)
    {
        stat = gen_yajl_object_residual (ptr->_residual, g, err);
        if (yajl_gen_status_ok != stat)
            GEN_SET_ERROR_AND_RETURN (stat, err);
    }
    stat = yajl_gen_map_close((yajl_gen)g);
    if (yajl_gen_status_ok != stat)
        GEN_SET_ERROR_AND_RETURN(stat, err);
    return yajl_gen_status_ok;
}


registry_manifest_schema2 *registry_manifest_schema2_parse_file(const char *filename, const struct parser_context *ctx, parser_error *err) {
    registry_manifest_schema2 *ptr = NULL;
    size_t filesize;
    char *content = NULL;

    if (filename == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = read_file(filename, &filesize);
    if (content == NULL) {
        if (asprintf(err, "cannot read the file: %s", filename) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = registry_manifest_schema2_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

registry_manifest_schema2 *registry_manifest_schema2_parse_file_stream(FILE *stream, const struct parser_context *ctx, parser_error *err) {
    registry_manifest_schema2 *ptr = NULL;
    size_t filesize;
    char *content = NULL ;

    if (stream == NULL || err == NULL)
        return NULL;

    *err = NULL;
    content = fread_file(stream, &filesize);
    if (content == NULL) {
        *err = safe_strdup("cannot read the file");
        return NULL;
    }
    ptr = registry_manifest_schema2_parse_data(content, ctx, err);
    free(content);
    return ptr;
}

registry_manifest_schema2 *registry_manifest_schema2_parse_data(const char *jsondata, const struct parser_context *ctx, parser_error *err) {
    registry_manifest_schema2 *ptr = NULL;
    yajl_val tree;
    char errbuf[1024];
    struct parser_context tmp_ctx = { 0 };

    if (jsondata == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (strlen(jsondata) >= JSON_MAX_SIZE) {
        if (asprintf(err, "cannot parse the data with length exceeding %llu", JSON_MAX_SIZE) < 0) {
            *err = safe_strdup("error allocating memory");
        }
        return NULL;
    }
    if (ctx == NULL) {
       ctx = (const struct parser_context *)(&tmp_ctx);
    }
    tree = yajl_tree_parse(jsondata, errbuf, sizeof(errbuf));
    if (tree == NULL) {
        if (asprintf(err, "cannot parse the data: %s", errbuf) < 0)
            *err = safe_strdup("error allocating memory");
        return NULL;
    }
    ptr = make_registry_manifest_schema2(tree, ctx, err);
    yajl_tree_free(tree);
    return ptr;
}
char *registry_manifest_schema2_generate_json(const registry_manifest_schema2 *ptr, const struct parser_context *ctx, parser_error *err) {
    yajl_gen g = NULL;
    struct parser_context tmp_ctx = { 0 };
    const unsigned char *gen_buf = NULL;
    char *json_buf = NULL;
    size_t gen_len = 0;

    if (ptr == NULL || err == NULL)
        return NULL;

    *err = NULL;
    if (ctx == NULL) {
        ctx = (const struct parser_context *)(&tmp_ctx);
    }

    if (!json_gen_init(&g, ctx)) {
        *err = safe_strdup("Json_gen init failed");
        goto out;
    }
    if (yajl_gen_status_ok != gen_registry_manifest_schema2(g, ptr, ctx, err)) {
        if (*err == NULL)
            *err = safe_strdup("Failed to generate json");
        goto free_out;
    }
    yajl_gen_get_buf(g, &gen_buf, &gen_len);
    if (gen_buf == NULL) {
        *err = safe_strdup("Error to get generated json");
        goto free_out;
    }

    json_buf = smart_safe_malloc(gen_len, 1, 1);
    (void)memcpy(json_buf, gen_buf, gen_len);
    json_buf[gen_len] = '\0';

free_out:
    yajl_gen_clear(g);
    yajl_gen_free(g);
out:
    return json_buf;
}

